program Main;

{ This program was written by Peter Lewis, Aug 1991 in THINK Pascal }
	uses
		MyOOMainLoop, MyOOMenus, MyNotifier, MyAppleEvents, TCPConnections, MyStrH, MyUtils,{}
		MyInternetMenu, Fingers, MyGrowZones, Preferences, MyPrinting, MyTEPrinting, MyOOAboutHelp,{}
		MyNewPreferences, MySystemGlobals, MyFMenus, MyTypes, MyMenus, AppGlobals, {}
		BaseGlobals, PrefCodes, MyFileSystemUtils, MyExpiry, QAlerts;

	var
		launched_with_option: boolean;

	function DoOApp: OSErr;
	begin
		DoOApp := noErr;
	end;

	function DoODoc (fs: FSSpec): OSErr;
		var
			err, junk: OSErr;
			rn: integer;
			s: str255;
	begin
		err := FSpOpenDF(fs, fsRdPerm, rn);
		if err = noErr then begin
			err := MyFSReadLine(rn, s);
			if (err = noErr) then begin
				if (length(s) > 4) & (s[4] = spc) then begin
					Delete(s, 1, 4);
					ParseURL(s, false);
					DoFingerCommand(s);
				end;
			end;
			junk := FSClose(rn);
		end;
		DoODoc := err;
	end;

	function DoQuit: OSErr;
	begin
		quitNow := true;
		DoQuit := noErr;
	end;

	procedure SetFingerMenu (themenu, theitem: integer);
		var
			t, c: longInt;
	begin
		SetIDItemEnable(themenu, theitem, EnoughSpace(0, 12000));
	end;

	procedure SetPrintMenu (themenu, theitem: integer);
	begin
		SetIDItemEnable(themenu, theitem, IsFingerWindow(FrontWindow));
	end;

	procedure SetGoodPort;
		var
			wmgrportP: ^grafptr;
	begin
		if FrontWindow <> nil then
			SetPort(FrontWindow)
		else begin
			wmgrportP := POINTER($9DE);
			Setport(wmgrportP^);
		end;
	end;

	function HandleMainEvents (var er: eventRecord): boolean;
		var
			b: boolean;
			fw: windowPtr;
	begin
		SetGoodPort;
		if SetOOMenuBar then
			DrawMenuBar;
		NotifyIdle(InForeground);
		fw := FrontWindow;
		b := GetWObject(fw).WaitForEvent(er, 10);
		b := GetWObject(fw).HandleEvents(er);
		SetGoodPort;
		HandleMainEvents := b;
	end;

	procedure MyDoFMenu (themenu, theitem: integer);
		var
			s: str255;
	begin
		giveOoMerror := true;
		case themenu of
			M_InternetTo:  begin
				DoFingerCommand(GetInternetCommand(themenu, theitem));
				HiliteMenu(0);
			end;
			M_RemoveTo:  begin
				RemoveInternetCommand(themenu, theitem);
				HiliteMenu(0);
			end;
			otherwise
				DoFMenu(themenu, theitem);
		end;
	end;

	var
		pob: TEPObject;

	procedure MyPrint;
		var
			junk: OSErr;
	begin
		pob.te := GetFingerTE(FrontWindow);
		junk := PrintStuff(pob, thePrintingRecordHandle);
	end;

	procedure MyPageSetup;
		var
			junk: OSErr;
	begin
		junk := DoPageSetup(pob, thePrintingRecordHandle);
	end;

	var
		last_about_click_count: longInt;
		random_about_index: integer;

	type
		MyAboutStringsObject = object(AboutStringsObject)
				function GetString (index: integer): str255;
				override;
			end;

	function MyAboutStringsObject.GetString (index: integer): str255;
		var
			s: str255;
			newrai: integer;
			val, val2: longInt;
			d: DateTimeRec;
	begin
		case index of
			3:  begin
				prefs.GetTagLong(P_Fingers, val);
				NumToString(val, s);
			end;
			4:  begin
				s := '?4?';
			end;
			5:  begin
				prefs.GetTagLong(P_Transferred, val);
				if val >= 10240 then begin
					NumToString(val div 1024, s);
					s := concat(s, '.', chr(48 + val mod 1024 div 103), GetIndStr(128, 12));
				end
				else begin
					NumToString(val, s);
					s := concat(s, GetIndStr(128, 13));
				end;
			end;
			6:  begin
				prefs.GetTagLong(P_DateStarted, val);
				IUDateString(val, abbrevDate, s);
			end;
			7:  begin
				GetIndString(s, 128, 10 + ord(prefs.GetTagBoolean(P_Paid)));
			end;
			8:  begin
				if last_about_click_count <> about_click_count then begin
					newrai := BAND(Random, $7FFF) mod (CountStrs(132) - 1) + 1;
					if newrai >= random_about_index then begin
						newrai := newrai + 1;
					end;
					random_about_index := newrai;
					last_about_click_count := about_click_count;
				end;
				GetIndString(s, 132, random_about_index);
			end;
			otherwise
				s := inherited GetString(index);
		end;
		GetString := s;
	end;

	var
		er: eventRecord;
		paramCount, paramMessage: integer;
		af: appFile;
		oe: OSErr;
		dummyb: boolean;
		mainloop_dobj: DefObject;
		a, i: integer;
		appllimitP: ^longInt;
		gv: longInt;
		fs: FSSpec;
		about_strings_object: MyAboutStringsObject;
begin
	HaveResources;
	InitSystemGlobals;
	InitGrowZone(8000, outofmem_alert_id);
	if MemoryCritical then begin
		a := Alert(outofmem_alert_id, nil);
		halt;
	end;
	giveOoMerror := true;
	dummyb := GetOSEvent(0, er);
	launched_with_option := BAND(er.modifiers, optionKey) <> 0;
	InitNotify;
	oe := InitQAlerts(128, 1, nil, '');
	GetDateTime(randSeed);
	if not ExpiredVersion(compdate, 3, 4) then begin
		if has_AppleEvents then begin
			oe := InitAppleEvents(@DoOApp, @DoODoc, nil, @DoQuit);
		end;
		oe := InitConnections;
		if oe <> noErr then begin
			FailAlert(8, '', oe);
			halt;
		end;
		new(mainloop_dobj);
		InitMainLoop(DObject(mainloop_dobj), @MyDoFMenu);
		InitOOMenus(nil);
		new(about_strings_object);
		InitAboutHelp(about_strings_object);
		last_about_click_count := about_click_count - 1;
		InitPrinting;
		new(pob);
		pob.Create;
		InitPreferences(prefsStrhResID, -1, prefsNameStrhIndex, 'PnLF');
		InitPreferencesR;
		SetDefaultPrefs;
		SetFBoth(Cfinger, @Finger, @SetFingerMenu);
		SetFCommand(CPageSetup, @MyPageSetup);
		SetFBoth(Cprint, @MyPrint, @SetPrintMenu);
		InitCursor;
		InitInternetMenu;
		InitFingers;
		DisplayMenuBar;

		if prefs.GetTagBoolean(P_AutoOpen) then begin
			Finger;
		end;
		if not prefs.GetTagBoolean(P_Paid) then begin
			OpenAboutBox;
		end;

		while not quitNow do begin
			IdleGrowZone;
			dummyb := HandleMainEvents(er);
			HandleFingerTCPEvents;
			QAlertIdle(InForeground);
			if quitNow then
				quitNow := not FinishPreferencesR;
		end;

		pob.Destroy;
		FinishPrinting;
		FinishFingers;
		WritePrefsData;
		FinishPreferences;
		FinishInternetMenu;
		FinishOOmenus;
		FinishMainLoop;
		FinishEverything;  { buggers up the resources for some god forsaken reason }
	end;
	TermQAlerts;
	FinishNotify;
	FinishGrowZone;
end.