unit PrefCodes;

interface

	const
		prefsStrhResID = 128;
		prefsFolderStrhIndex = -1;
		prefsNameStrhIndex = 1;

	const
		P_showIP = 'shIP';
		P_AutoOpen = 'AuOp';
		P_Paid = 'Paid';
		P_DateStarted = 'Date';
		P_Fingers = 'Tusr';
		P_Transferred = 'Tfil';
		P_UsageVersion = 'Usag';

	procedure SetDefaultPrefs;

implementation

	uses
		ToolUtils, MyNewPreferences;

	procedure SetDefaultPrefs;
		procedure SetDef (code: OSType; def: boolean);
		begin
			if not prefs.ExistsTag(code) then begin
				prefs.SetTagBoolean(code, def);
			end;
		end;
		var
			date: longInt;
			s: str255;
	begin
		SetDef(P_showIP, false);
		SetDef(P_AutoOpen, false);
		SetDef(P_Paid, false);
		GetIndString(s, 140, 1);
		if s = '' then begin
			prefs.SetTagBoolean(P_Paid, true);
		end;
		if not prefs.ExistsTag(P_DateStarted) then begin
			GetDateTime(date);
			prefs.SetTagLong(P_DateStarted, date);
		end;
		prefs.SetTagLong(P_UsageVersion, 1);
	end;

end.